package com.example.gasullaj_proyectofundamentos;

import android.database.Cursor;
import android.os.Bundle;
import android.support.v4.app.FragmentActivity;

import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.SupportMapFragment;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.MarkerOptions;

public class Mapa extends FragmentActivity {
	private GoogleMap mapa;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.mapa);
		mapa = ((SupportMapFragment) getSupportFragmentManager()
				.findFragmentById(R.id.mapa)).getMap();
		mapa.setMapType(GoogleMap.MAP_TYPE_NORMAL);
		mapa.setMyLocationEnabled(true);
		mapa.getUiSettings().setZoomControlsEnabled(true);

		// Recuperamos el elemento de la lista de
		// puntuaciones sobre el que se ha pulsado
		Bundle extras = getIntent().getExtras();
		int position = extras.getInt("position");
		Cursor c = MainActivity.almacen.listaPuntuaciones(10);
		// Vamos a poner un marcador en cada una de
		// las posiciones de la lista de puntuaciones
		while (c.moveToNext()) {
			double latitud = c.getDouble(c.getColumnIndex("latitud"));
			double longitud = c.getDouble(c.getColumnIndex("longitud"));

			mapa.addMarker(new MarkerOptions()
					.position(new LatLng(latitud, longitud))
					.title(String.valueOf(c.getInt(c.getColumnIndex("puntos"))))
					.snippet(c.getString(c.getColumnIndex("nombre"))));

			// Si es el elemento de la lista sobre el que se ha pulsado,
			// centraremos la vista en ese punto y haremos zoom.
			if (c.getPosition() == position) {
				mapa.moveCamera(CameraUpdateFactory.newLatLngZoom(new LatLng(
						latitud, longitud), 10));
			}
		}
	}
}
