package com.example.gasullaj_proyectofundamentos;

import android.graphics.Rect;
import android.graphics.drawable.Drawable;
import android.view.View;

public class Plataforma extends Grafico {

	public static final int COLISION_NO = 0;
	public static final int COLISION_ARRIBA = 1;
	public static final int COLISION_ABAJO = 2;
	public static final int COLISION_IZQUIERDA = 3;
	public static final int COLISION_DERECHA = 4;
	
	private int tipoPlataforma;
	private boolean protaEnPlat = false;  // Indica si el Prota est sobre la plataforma
	
	public Plataforma(View view, Drawable drawable, int tipoPlataforma) {
		super(view, drawable);
		this.tipoPlataforma = tipoPlataforma;
	}

	// Indica en cual de los cuatro lados de la plataforma
	// ha colisionado el Grafico g, o en ninguno
	public int verificaColisionLados(Grafico g) {			
		int colision= COLISION_NO;
		
		int leftPlat   = this.getCenX() - this.getAncho()/2;
		int topPlat    = this.getCenY() - this.getAlto()/2;
		int rightPlat  = this.getCenX() + this.getAncho()/2;		
		int bottomPlat = this.getCenY() + this.getAlto()/2;
		Rect rectPlataforma = new Rect(leftPlat, topPlat, rightPlat, bottomPlat);

		int leftProta   = g.getCenX() - g.getAncho()/2;
		int topProta    = g.getCenY() - g.getAlto()/2;
		int rightProta  = g.getCenX() + g.getAncho()/2;		
		int bottomProta = g.getCenY() + g.getAlto()/2;
		Rect rectProta = new Rect(leftProta, topProta, rightProta, bottomProta);		
		
		if (Rect.intersects(rectPlataforma, rectProta)) {
            // rectProta contendr ahora el rectngulo interseccin
			rectProta.intersect(rectPlataforma);
            int rIcX = rectProta.centerX();
            int rIcY = rectProta.centerY();
            int rPlcX = rectPlataforma.centerX();
            int rPlcY = rectPlataforma.centerY();
            int difX = rIcX - rPlcX;
            int difY = rIcY - rPlcY;
            // Supongo plataformas de poca altura
            if (difY < 0) {
            	colision = COLISION_ARRIBA;
            } else if (difY > 0) {
            	colision = COLISION_ABAJO;           
            } else if (difX < 0) {
            	colision = COLISION_IZQUIERDA;
            } else if (difX > 0) {
            	colision = COLISION_DERECHA;
            }
        } 
	
		return colision;
	}

	public int getTipoPlataforma() {
		return tipoPlataforma;
	}

	public void setTipoPlataforma(int tipoPlataforma) {
		this.tipoPlataforma = tipoPlataforma;
	}

	public boolean isProtaEnPlat() {
		return protaEnPlat;
	}

	public void setProtaEnPlat(boolean protaEnPlat) {
		this.protaEnPlat = protaEnPlat;
	}	
}
